function love.load() -- Loads all the other scripts and defines all the functions from said scripts

	local Y = love.filesystem.load('physics.lua')
  local X = love.filesystem.load('graphics.lua')
  local T = love.filesystem.load('strManip.lua')
  local O = love.filesystem.load('objParser.lua')
  local physics = Y
  local graphics = X
  local strManip = T
  local objParser = O

  local print = graphics(0).print -- Graphics functions
  local clear = graphics(0).clear
  local color = graphics(0).color
  local drawEllipse = graphics(0).drawEllipse
  local drawEllipseF = graphics(0).drawEllipseF
  local drawBox3D = graphics(0).drawBox3D
  local drawLine = graphics(0).drawLine

  local split = strManip(0).split -- String manipulation functions
  local starts = strManip(0).starts
  local ends = strManip(0).ends

  local parseObj = objParser(0).parseObj

  onStartup()
end


function readConfigFile(_index) -- Returns the config file's data (Yes, I know calling a filesystem.read many times in a short period is a bad idea, but I don't really care.)
  conversionStep1 = {}
  conversionStep2 = {}

  local config = love.filesystem.read("config.txt") -- Get the content of config.txt

  conversionStep1 = split(config,"\n") -- Split all the config options into a table

  for i=1,#conversionStep1 do -- Split the config option name and the value
    conversionStep2[i] = split(conversionStep1[i], "%s")
  end

  return conversionStep2[_index]
end

function love.update(dt) -- Function is called every frame
  onTick(dt)
end


function love.draw() -- Function is called every time the script draws to the screen
  onDraw()
end



function onStartup() -- Runs on application startup
  objFile = 'cube.obj'
  objArray = {}
  points1 = {{-40, -40, -40}, {-40, -40, 40}, {-40, 40, -40}, {-40, 40, 40}, {40, -40, -40}, {40, -40, 40}, {40, 40, -40}, {40, 40, 40}}
  lines1 = {{1,2},{2,4},{4,3},{3,1},{5,6},{6,8},{8,7},{7,5},{1,5},{2,6},{3,7},{4,8}}


  points2 = {}
  lines2 = {
    {1, 2, 3, 1}, {3, 2, 4, 2},
    {1, 5, 2, 3}, {2, 5, 6, 4},
    {3, 4, 7, 5}, {8, 7, 4, 6},
    {5, 6, 7, 7}, {8, 7, 6, 8},
    {8, 4, 6, 9}, {6, 4, 2, 10},
    {3, 5, 7, 11}, {1, 5, 3, 12}
  }
  degX = 0
  degY = 0
  degZ = 0
  sensitivity = 0.05
  points2 = parseObj(objFile)[1] -- Get the vertex positions of the obj file and render the cube using them
end


function onTick(dt)
  if love.keyboard.isDown("w") then
    degX = degX - sensitivity
    points1 = rotPointsX(degX, points1)
    points2 = rotPointsX(degX, points2)
    degX = 0
  end
  if love.keyboard.isDown("s") then
    degX = degX + sensitivity
    points1 = rotPointsX(degX, points1)
    points2 = rotPointsX(degX, points2)
    degX = 0
  end

  if love.keyboard.isDown("a") then
    degY = degY + sensitivity
    points1 = rotPointsY(degY, points1)
    points2 = rotPointsY(degY, points2)
    degY = 0
  end
  if love.keyboard.isDown("d") then
    degY = degY - sensitivity
    points1 = rotPointsY(degY, points1)
    points2 = rotPointsY(degY, points2)
    degY = 0
  end

  points1 = rotPointsZ(degZ, points1)
  
  
  points2 = rotPointsZ(degZ, points2)
  
  
end

function onDraw()
  print("WASD to rotate", 20, 400)
  print(tostring(readConfigFile(1)[1]), 0, 0)
  print(tostring(readConfigFile(1)[2]), 0, 10)


  --drawShape3D(120, 120, "onlyLines", points1, lines1, 4, color(0, 255, 0), color(0, 0, 255), color(0, 0, 0))
  --drawShape3D(300, 120, "onlyPoints", points1, lines1, 4, color(0, 255, 0), color(0, 0, 255), color(0, 0, 0))
  drawShape3D(300, 300, "faces", points2, lines2, 4, color(0, 255, 0), color(0, 0, 255), color(255, 255, 255), {300, 300, -100})
end